Loading...
Searching...
No Matches
Undirector< DGR > Class Template Reference
Data Structures » Graph Structures » Adaptor Classes for Graphs

## Detailed Description

template<typename DGR>
class lemon::Undirector< DGR >

Undirector adaptor can be used for viewing a digraph as an undirected graph. All arcs of the underlying digraph are showed in the adaptor as an edge (and also as a pair of arcs, of course). This adaptor conforms to the Graph concept.

The adapted digraph can also be modified through this adaptor by adding or removing nodes or edges, unless the `GR` template parameter is set to be `const`.

This class provides item counting in the same time as the adapted digraph structure.

Template Parameters

  DGR | The type of the adapted digraph. It must conform to the Digraph concept. It can also be specified to be `const`.

Note
  The `Node` type of this adaptor and the adapted digraph are convertible to each other, moreover the `Edge` type of the adaptor and the `Arc` type of the adapted digraph are also convertible to each other. (Thus the `Arc` type of the adaptor is convertible to the `Arc` type of the adapted digraph.)

`#include <lemon/adaptors.h>`

## Classes

class | CombinedArcMap
| Arc map combined from two original arc maps. More...

## Public Types

typedef DGR | Digraph
| The type of the adapted digraph.

## Public Member Functions

| Undirector (DGR &digraph)
| Constructor.

## Static Public Member Functions

template<typename FW, typename BK>
static CombinedArcMap< FW, BK > | combinedArcMap (FW &forward, BK &backward)
| Returns a combined arc map.

## Related Symbols

(Note that these are not member symbols.)
template<typename DGR>
Undirector< const DGR > | undirector (const DGR &digraph)
| Returns a read-only Undirector adaptor.

## Constructor & Destructor Documentation

## Undirector()

template<typename DGR>

Undirector | ( | DGR & | digraph | ) |

inline

Creates an undirected graph from the given digraph.

## Member Function Documentation

## combinedArcMap()

template<typename DGR>
template<typename FW, typename BK>

CombinedArcMap< FW, BK > combinedArcMap | ( | FW & | forward,
|  | BK & | backward )

inline static

This function just returns a combined arc map.